#! /bin/sh /usr/share/dpatch/dpatch-run
## 06_s390_sparc64_syscall.dpatch by Micah Anderson <Micah Anderson <micah@debian.org>>
##
## All lines beginning with `## DP:' are a description of the patch.
## DP: No description.

@DPATCH@
diff -urNad trunk~/lib_internal/sys_clone.h trunk/lib_internal/sys_clone.h
--- trunk~/lib_internal/sys_clone.h	2006-03-20 08:16:48.000000000 -0500
+++ trunk/lib_internal/sys_clone.h	2006-04-05 23:13:36.000000000 -0400
@@ -19,33 +19,61 @@
 #ifndef H_UTIL_VSERVER_SRC_SYS_CLONE_H
 #define H_UTIL_VSERVER_SRC_SYS_CLONE_H
 
+#include <unistd.h>
 #include "lib/syscall-wrap.h"
-#define __NR_sys_clone		__NR_clone
+#define __NR__sys_clone		__NR_clone
 
 #ifndef CLONE_NEWNS
 #  define CLONE_NEWNS 0x00020000
 #endif
 
 #ifdef ENSC_SYSCALL_TRADITIONAL
-#include <unistd.h>
-
 inline static UNUSED ALWAYSINLINE
-int sys_clone(int flags, void *stack)
+int _sys_clone(int flags, void *stack)
 {
-#if defined __dietlibc__
+#  if defined __dietlibc__
   extern long int syscall (long int __sysno, ...);
-#endif
+#  endif
  
-  return syscall(__NR_sys_clone, flags, stack);
+#  if defined(__s390__)
+  return syscall(__NR__sys_clone, stack, flags);
+#  else
+  return syscall(__NR__sys_clone, flags, stack);
+#  endif
 }
 #else
-#include <errno.h>
+#  include <errno.h>
 
+#  if defined(__s390__)
 inline static UNUSED ALWAYSINLINE
-_syscall2(int, sys_clone, int, flags, void *, child_stack)
+_syscall2(int, _sys_clone, void *, child_stack, int, flags)
+#  else
+inline static UNUSED ALWAYSINLINE
+_syscall2(int, _sys_clone, int, flags, void *, child_stack)
+#  endif
 #endif
 
-#undef __NR_sys_clone
+inline static UNUSED ALWAYSINLINE
+int sys_clone(int flags, void *child_stack)
+{
+  int ret;
+#ifdef __sparc__
+  int parent = getpid();
+#endif
+
+#if defined(__s390__) && !defined(ENSC_SYSCALL_TRADITIONAL)
+  ret = _sys_clone(child_stack, flags);
+#else
+  ret = _sys_clone(flags, child_stack);
+#endif
+#ifdef __sparc__
+  if (ret == parent)
+    ret = 0;
+#endif
+  return ret;
+}
+
+#undef __NR__sys_clone
 
 #define ENSC_HAVE_SYSCLONE		1
   
